-- name: [CS] Paper Partners 64 3.3
-- description: Skinpack of famous friends from the Paper Mario series! \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local E_MODEL_GOOMBARIO = smlua_model_util_get_id("goombario_geo")
local E_MODEL_KOOPER = smlua_model_util_get_id("kooper_geo")
local E_MODEL_PARAKARRY = smlua_model_util_get_id("parakarry_geo")
local E_MODEL_BOMBETTE = smlua_model_util_get_id("bombette_geo")
local E_MODEL_WATT = smlua_model_util_get_id("watt_geo")
local E_MODEL_SUSHIE = smlua_model_util_get_id("sushie_geo")
local E_MODEL_LAKILESTER = smlua_model_util_get_id("lakilester_geo")
local E_MODEL_BOW = smlua_model_util_get_id("bow_geo")

local TEX_GOOMBARIO = get_texture_info("goombario_icon")
local TEX_KOOPER = get_texture_info("kooper_icon")
local TEX_PARAKARRY = get_texture_info("parakarry_icon")
local TEX_BOMBETTE = get_texture_info("bombette_icon")
local TEX_WATT = get_texture_info("watt_icon")
local TEX_SUSHIE = get_texture_info("sushie_icon")
local TEX_LAKILESTER = get_texture_info("lakilester_icon")
local TEX_BOW = get_texture_info("bow_icon")

local E_MODEL_STAR_ELDSTAR = smlua_model_util_get_id("eldstar_geo")
local TEX_STAR_ELDSTAR = get_texture_info("eldstar_icon")

local E_MODEL_STAR_MAMAR = smlua_model_util_get_id("mamar_geo")
local TEX_STAR_MAMAR = get_texture_info("mamar_icon")

local E_MODEL_STAR_SKOLAR = smlua_model_util_get_id("skolar_geo")
local TEX_STAR_SKOLAR = get_texture_info("skolar_icon")

local E_MODEL_STAR_MUSKULAR = smlua_model_util_get_id("muskular_geo")
local TEX_STAR_MUSKULAR = get_texture_info("muskular_icon")

local E_MODEL_STAR_MISSTAR = smlua_model_util_get_id("misstar_geo")
local TEX_STAR_MISSTAR = get_texture_info("misstar_icon")

local E_MODEL_STAR_KLEVAR = smlua_model_util_get_id("klevar_geo")
local TEX_STAR_KLEVAR = get_texture_info("klevar_icon")

local E_MODEL_STAR_KALMAR = smlua_model_util_get_id("kalmar_geo")
local TEX_STAR_KALMAR = get_texture_info("kalmar_icon")

local TEXT_MOD_NAME = "[CS] Paper Partners 64"

local VOICETABLE_GOOMBA = {
    [CHAR_SOUND_YAH_WAH_HOO] = 'Gyah.ogg',
    [CHAR_SOUND_HOOHOO] = 'Ghoohoo (2).ogg',
    [CHAR_SOUND_YAHOO] = 'Gyahooyipee.ogg',
    [CHAR_SOUND_UH] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_HRMM] = 'Ghrm.ogg',
    [CHAR_SOUND_WAH2] = 'Gwah.ogg',
    [CHAR_SOUND_WHOA] = 'Gwhoa.ogg',
    [CHAR_SOUND_EEUH] = 'Geeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Gattacked.ogg',
    [CHAR_SOUND_OOOF] = 'Gooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ghere we go.ogg',
    [CHAR_SOUND_YAWNING] = 'Gyawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Gwaaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Ghaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Ghaha.ogg',
    [CHAR_SOUND_UH2] = 'Guh.ogg',
    [CHAR_SOUND_UH2_2] = 'Guh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Gfire.ogg',
    [CHAR_SOUND_DYING] = 'Gdying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PANTING] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_COUGHING1] = 'Gcoughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Gyah (2).ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Ghoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Gsurprise.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Gwah.ogg',
    [CHAR_SOUND_DROWNING] = 'Gdrowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Gwah_punch.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Gyahooyipee.ogg',
    [CHAR_SOUND_DOH] = 'Gdoh.ogg',
    [CHAR_SOUND_HELLO] = 'Ghello.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Gquestion.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Gsolongabowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Gimatired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Gletsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Goki doki.ogg',
}

local VOICETABLE_KOOPA = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Kya.ogg', 'Kwah.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Khoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Kyahoo.ogg',
    [CHAR_SOUND_UH] = 'Kuh.ogg',
    [CHAR_SOUND_HRMM] = 'Khrm.ogg',
    [CHAR_SOUND_WAH2] = 'Kwah.ogg',
    [CHAR_SOUND_WHOA] = 'Kwhoa.ogg',
    [CHAR_SOUND_EEUH] = 'Keh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Kdoh.ogg',
    [CHAR_SOUND_OOOF] = 'Khurt.ogg',
    [CHAR_SOUND_OOOF2] = 'Keh2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ktwirl_bounce.ogg',
    [CHAR_SOUND_YAWNING] = 'Kyawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Kwoaaaw.ogg',
    [CHAR_SOUND_HAHA] = 'Khaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Khaha.ogg',
    [CHAR_SOUND_UH2] = 'Kuh.ogg',
    [CHAR_SOUND_UH2_2] = 'Kuh2-2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Kfire.ogg',
    [CHAR_SOUND_DYING] = 'Kdying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Kcoughing2.ogg',
    [CHAR_SOUND_PANTING] = 'Kcoughing2.ogg',
    [CHAR_SOUND_COUGHING1] = 'Kcoughing2.ogg',
    [CHAR_SOUND_COUGHING2] = 'Kcoughing3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Kyah2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Khoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Kwoaaaw.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Kwah2.ogg',
    [CHAR_SOUND_DROWNING] = 'Kdrowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Kwah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Ksolonga_bowser.ogg', 'Ktwirl_bounce.ogg' },
    [CHAR_SOUND_DOH] = 'Kdoh.ogg',
    [CHAR_SOUND_HELLO] = 'Khello.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Ktwirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Ksolonga_bowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Khurt.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Klets a go.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Kokey_dokey.ogg',
}

local VOICETABLE_BOBOMB = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Bo_yah.ogg', 'Bo_yah2.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Bo_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Bo_yahoo.ogg',
    [CHAR_SOUND_UH] = 'Bo_uh.ogg',
    [CHAR_SOUND_HRMM] = 'Bo_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'Bo_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'Bo_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'Bo_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Bo_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'Bo_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Bo_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Bo_herewego.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Bo_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Bo_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Bo_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'Bo_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'Bo_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Bo_onfire.ogg',
    [CHAR_SOUND_DYING] = 'Bo_dying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Bo_panting_cold.ogg',
    [CHAR_SOUND_PANTING] = 'Bo_panting.ogg',
    [CHAR_SOUND_COUGHING1] = 'Bo_coughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Bo_coughing2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Bo_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Bo_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Bo_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Bo_groundpound.ogg',
    [CHAR_SOUND_DROWNING] = 'Bo_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Bo_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Bo_yahoo.ogg', 'Bo_waha.ogg', 'Bo_wihee.ogg' },
    [CHAR_SOUND_DOH] = 'Bo_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Bo_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Bo_solongabowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Bo_letsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Bo_okey_dokey.ogg',
}
local VOICETABLE_WATT = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'W_yah.ogg', 'W_yah2.ogg', 'W_yah3.ogg', 'W_wah.ogg' },
    [CHAR_SOUND_HOOHOO] = 'W_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'W_whooo.ogg',
    [CHAR_SOUND_UH] = 'W_uh.ogg',
    [CHAR_SOUND_HRMM] = 'W_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'W_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'W_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'W_euuh.ogg',
    [CHAR_SOUND_ATTACKED] = { 'W_attacked.ogg', 'W_attacked_2.ogg', 'W_attacked_3.ogg' },
    [CHAR_SOUND_OOOF] = 'W_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'W_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'W_here_we_go.ogg',
    [CHAR_SOUND_YAWNING] = 'W_yawning.ogg',
    [CHAR_SOUND_SNORING1] = 'W_snoring_1.ogg',
    [CHAR_SOUND_SNORING2] = 'W_snoring_2.ogg',
    [CHAR_SOUND_SNORING3] = 'W_snoring_3.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'W_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'W_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'W_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'W_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'W_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'W_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'W_dying.ogg',
    [CHAR_SOUND_PANTING] = { 'W_panting.ogg', 'W_panting2.ogg', 'W_panting3.ogg' },
    [CHAR_SOUND_PANTING_COLD] = 'W_panting_cold.ogg',
    [CHAR_SOUND_COUGHING1] = 'W_coughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'W_coughing_2.ogg',
    [CHAR_SOUND_COUGHING3] = 'W_coughing_3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'W_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'W_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'W_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'W_ground_pound_wah.ogg',
    [CHAR_SOUND_DROWNING] = 'W_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'W_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'W_yahoo.ogg', 'W_yahoo2.ogg', 'W_yahoo3.ogg', 'W_yahoo4.ogg' },
    [CHAR_SOUND_DOH] = 'W_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'W_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'W_so_longa_bowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'W_ima_tired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'W_lets_a_go.ogg',
}

local VOICETABLE_SUSHIE = {
    [CHAR_SOUND_YAH_WAH_HOO] = 'bubbble1.ogg',
    [CHAR_SOUND_HOOHOO] = 'bubble2.ogg',
    [CHAR_SOUND_YAHOO] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_UH] = 'wet ladning.ogg',
    [CHAR_SOUND_HRMM] = 'bubbble1.ogg',
    [CHAR_SOUND_WAH2] = 'bubble high$.ogg',
    [CHAR_SOUND_WHOA] = 'wet ladning.ogg',
    [CHAR_SOUND_EEUH] = 'bubble2.ogg',
    [CHAR_SOUND_ATTACKED] = 'bubblerun.ogg',
    [CHAR_SOUND_OOOF] = 'wet ladning.ogg',
    [CHAR_SOUND_OOOF2] = 'bubble2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_HAHA] = 'bubble2.ogg',
    [CHAR_SOUND_HAHA_2] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_UH2] = 'bubblerun.ogg',
    [CHAR_SOUND_UH2_2] = 'bubblerun.ogg',
    [CHAR_SOUND_ON_FIRE] = 'bubblepop2.ogg',
    [CHAR_SOUND_DYING] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_PANTING] = 'sleeping1.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'bubbble1.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_DROWNING] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'bubble2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_DOH] = 'wet ladning.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'boing.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'SUSHIESHOT.ogg',
}

local VOICETABLE_LAKILESTER = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'L_ya.ogg', 'L_yah2.ogg', 'L_yah3.ogg' },
    [CHAR_SOUND_HOOHOO] = 'L_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'L_yahoo (2).ogg',
    [CHAR_SOUND_UH] = 'L_uh.ogg',
    [CHAR_SOUND_HRMM] = 'L_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'L_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'L_woah.ogg',
    [CHAR_SOUND_EEUH] = 'L_euuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'L_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'L_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'L_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'L_here_we_go.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'L_falling2.ogg',
    [CHAR_SOUND_HAHA] = 'L_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'L_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'L_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'L_uh2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'L_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'L_dying.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'L_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'L_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'L_mamamia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'L_groundpound.ogg',
    [CHAR_SOUND_DROWNING] = 'L_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'L_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'L_yahoo.ogg', 'L_yipee2.ogg', 'L_yahoo (2).ogg', 'L_waha (2).ogg', 'L_waha.ogg' },
    [CHAR_SOUND_DOH] = 'L_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'L_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'L_so_longa_bowser.ogg',
}

local VOICETABLE_BOW = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Lb_yah1.ogg', 'Lb_haha.ogg', 'Lb_eeuh.ogg', 'Lb_doh.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Lb_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Lb_yahoo.ogg',
    [CHAR_SOUND_UH] = 'Lb_uh.ogg',
    [CHAR_SOUND_HRMM] = 'Lb_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'Lb_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'Lb_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'Lb_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Lb_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'Lb_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Lb_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Lb_here_we_go.ogg',
    [CHAR_SOUND_YAWNING] = 'Lb_yawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Lb_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Lb_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Lb_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'Lb_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'Lb_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Lb_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'Lb_dying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Lb_panting_cold.ogg',
    [CHAR_SOUND_PANTING] = 'Lb_panting.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Lb_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Lb_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Lb_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Lb_ground_pound_wah.ogg',
    [CHAR_SOUND_DROWNING] = 'Lb_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Lb_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Lb_yahoo.ogg', 'Lb_yahoo2.ogg', 'Lb_yahoo3.ogg', 'Lb_yahoo4.ogg', 'Lb_yahoo5.ogg', 'Lb_waha.ogg', 'Lb_yipee.ogg' },
    [CHAR_SOUND_DOH] = 'Lb_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Lb_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Lb_so_longa_bowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Lb_lets_a_go.ogg',
}


local VOICETABLE_SILENT = { nil }


local capGoombario = {
    normal = smlua_model_util_get_id("goombarios_cap_geo"),
    wing = smlua_model_util_get_id("goombarios_wing_cap_geo"),
    metal = smlua_model_util_get_id("goombarios_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("goombarios_metal_wing_cap_geo")
}

local capKooper = {
    normal = smlua_model_util_get_id("koopers_cap_geo"),
    wing = smlua_model_util_get_id("koopers_wing_cap_geo"),
    metal = smlua_model_util_get_id("koopers_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("koopers_metal_wing_cap_geo")
}



local capParakarry = {
    normal = smlua_model_util_get_id("parakarrys_cap_geo"),
    wing = smlua_model_util_get_id("parakarrys_wing_cap_geo"),
    metal = smlua_model_util_get_id("parakarrys_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("parakarrys_metal_wing_cap_geo")
}

local capBombette = {
    normal = smlua_model_util_get_id("bombette_cap_geo"),
    wing = smlua_model_util_get_id("bombette_wing_cap_geo"),
    metal = smlua_model_util_get_id("bombette_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bombette_metal_wing_cap_geo")
}

local capWatt = {
    normal = smlua_model_util_get_id("watts_cap_geo"),
    wing = smlua_model_util_get_id("watts_wing_cap_geo"),
    metal = smlua_model_util_get_id("watts_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("watts_metal_wing_cap_geo")
}

local capSushie = {
    normal = smlua_model_util_get_id("sushies_cap_geo"),
    wing = smlua_model_util_get_id("sushies_wing_cap_geo"),
    metal = smlua_model_util_get_id("sushies_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("sushie_metal_wing_cap_geo")
}

local capLakilester = {
    normal = smlua_model_util_get_id("lakilester_cap_geo"),
    wing = smlua_model_util_get_id("lakilester_wing_cap_geo"),
    metal = smlua_model_util_get_id("lakilester_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("lakilester_metal_wing_cap_geo")
}

local capBow = {
    normal = smlua_model_util_get_id("bow_cap_geo"),
    wing = smlua_model_util_get_id("bow_wing_cap_geo"),
    metal = smlua_model_util_get_id("bow_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bow_metal_wing_cap_geo")
}



local PALETTE_GOOMBARIO = {
    [PANTS] = "214aa5",
    [SHIRT] = "9c5210",
    [SHOES] = "5a2100",
    [SKIN]  = "bd8439",
}



local PALETTE_KOOPER = {
    [PANTS]  = "d64231",
    [SHIRT]  = "3963ce",
    [GLOVES] = "bdad84",
    [SHOES]  = "b56b31",
    [HAIR]   = "ce9431",
    [SKIN]   = "ce9431",
    [CAP]    = "3963ce",
}



local PALETTE_PARAKARRY = {
    [PANTS]  = "7b3908",
    [SHIRT]  = "109c84",
    [GLOVES] = "bdad84",
    [SHOES]  = "ce9431",
    [HAIR]   = "ce9431",
    [SKIN]   = "ce9431",
    [CAP]    = "ce9431",
}

local PALETTE_BOMBETTE = {
    [SHIRT]  = "f8005a",
    [GLOVES] = "ffffff",
    [SHOES]  = "f17b2e",
    [HAIR]   = "ffc81d",
    [SKIN]   = "f8a773",
}

local PALETTE_LADY_BOW = {
    [PANTS]  = "d6d65a",
    [SHIRT]  = "f74a31",
    [GLOVES] = "cdfddf",
}

local PALETTE_WATT = {
    [PANTS] = "73c7ef",
    [SHIRT] = "f7e329",
    [CAP]   = "f7e329",
}

local PALETTE_SUSHIE = {
    [PANTS]  = "ef7929",
    [SHIRT]  = "7b57f5",
    [GLOVES] = "ffffff",
    [SKIN]   = "e7d37b",
    [CAP]    = "ef92bd",
}

local PALETTE_LAKILESTER = {
    [SHIRT]  = "49ff31",
    [GLOVES] = "ffffff",
    [SHOES]  = "9c5129",
    [SKIN]   = "efaa4a",
}




local char_add, char_add_caps, char_add_palette, char_add_voice, char_add_star, char_get_voice =
    _G.charSelect.character_add, _G.charSelect.character_add_caps, _G.charSelect.character_add_palette_preset,
    _G.charSelect.character_add_voice, _G.charSelect.character_add_celebration_star, _G.charSelect.character_get_voice

char_add_caps(E_MODEL_GOOMBARIO, capGoombario)
char_add_caps(E_MODEL_KOOPER, capKooper)
char_add_caps(E_MODEL_PARAKARRY, capParakarry)
char_add_caps(E_MODEL_BOMBETTE, capBombette)
char_add_caps(E_MODEL_WATT, capWatt)
char_add_caps(E_MODEL_SUSHIE, capSushie)
char_add_caps(E_MODEL_LAKILESTER, capLakilester)
char_add_caps(E_MODEL_BOW, capBow)



local PM_KOOPA = {
    label = {
        left = get_texture_info("koopa_pm1"),
        right = get_texture_info("koopa_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}


local PM_GOOMBARIO = {
    label = {
        left = get_texture_info("goombario_pm1"),
        right = get_texture_info("goombario_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_BOMBETTE = {
    label = {
        left = get_texture_info("bombette_pm1"),
        right = get_texture_info("bombette_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_BOW = {
    label = {
        left = get_texture_info("bow_pm1"),
        right = get_texture_info("bow_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_WATT = {
    label = {
        left = get_texture_info("watt_pm1"),
        right = get_texture_info("watt_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_SUSHIE = {
    label = {
        left = get_texture_info("sushie_pm1"),
        right = get_texture_info("sushie_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_LAKILESTER = {
    label = {
        left = get_texture_info("lakilester_pm1"),
        right = get_texture_info("lakilester_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

if not _G.charSelectExists then
    djui_popup_create(
        "\\#ffffdc\\\n" ..
        TEXT_MOD_NAME ..
        "\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!",
        6)
    return
end

CT_GOOMBARIO = char_add("Goombario",
    "A young member of the Goomba family in Goomba Village, Goombario has always been a big fan of Mario. Like most Goombas, he has a hard head and a fighting spirit. He knows a great deal about the Mushroom Kingdom and will clue you in on most anything you'd like to know.",
    "Melzinoff", { r = 180, g = 116, b = 63 }, E_MODEL_GOOMBARIO, CT_TOAD, TEX_GOOMBARIO)
CT_KOOPER = char_add("Kooper",
    "Kooper is Mario's second party member in Paper Mario. He is a blue, bold, adventure-loving (and seemingly young) Koopa who dreams of becoming an archaeologist like his childhood hero Kolorado.",
    "Melzinoff", { r = 55, g = 122, b = 255 }, E_MODEL_KOOPER, CT_LUIGI, TEX_KOOPER)
CT_BOMBETTE = char_add("Bombette",
    "Hot-headed Bombette was once jailed in Koopa Bros. Fortress. That pink is adorable!", "Melzinoff",
    { r = 234, g = 0, b = 124 }, E_MODEL_BOMBETTE, CT_MARIO, TEX_BOMBETTE)
CT_PARAKARRY = char_add("Parakarry",
    "His name is Parakarry. He's a Paratroopa who works for the post office. He's well known for being the slowest mailman around. A slow mailman? That can't be good.",
    "Melzinoff", { r = 214, g = 131, b = 22 }, E_MODEL_PARAKARRY, CT_LUIGI, TEX_PARAKARRY)
CT_BOW = char_add("Lady Bow",
    "Bow is a princess of a Boo, who has a castle in Forever Forest. As the head Boo of Boo's Mansion, she always knows how to get her way.",
    "Melzinoff", { r = 201, g = 217, b = 208 }, E_MODEL_BOW, CT_MARIO, TEX_BOW)
CT_WATT = char_add("Watt",
    "The captive of Big Lantern Ghost in Shy Guy's Toy Box, she can shed light on your adventure.",
    "Melzinoff & Gauntlet Queen", { r = 214, g = 208, b = 104 }, E_MODEL_WATT, CT_MARIO, TEX_WATT)
CT_SUSHIE = char_add("Sushie",
    "Sushie's a kindly Cheep Cheep who worries about everyone. She loves romantic stories and cries at the drop of a fin.",
    "Melzinoff", { r = 137, g = 103, b = 198 }, E_MODEL_SUSHIE, CT_MARIO, TEX_SUSHIE)
CT_LAKILESTER = char_add("Lakilester",
    "Even though it says Lakilester on his cloud riding license, the green-haired Spiny-tosser calls himself Spike.",
    "Melzinoff", { r = 50, g = 164, b = 2 }, E_MODEL_LAKILESTER, CT_MARIO, TEX_LAKILESTER)

do

end


char_add_palette(E_MODEL_GOOMBARIO, PALETTE_GOOMBARIO)
char_add_palette(E_MODEL_KOOPER, PALETTE_KOOPER)

char_add_palette(E_MODEL_PARAKARRY, PALETTE_PARAKARRY)
char_add_palette(E_MODEL_BOMBETTE, PALETTE_BOMBETTE)

char_add_palette(E_MODEL_WATT, PALETTE_WATT)
char_add_palette(E_MODEL_SUSHIE, PALETTE_SUSHIE)
char_add_palette(E_MODEL_LAKILESTER, PALETTE_LAKILESTER)
char_add_palette(E_MODEL_BOW, PALETTE_LADY_BOW)


---- BOWSER Compatibility:
if _G.bowsMoveset then
    -- Retrieves the custom shell model for this character. Check template_shell.blend for how to set up a shell model properly.
    local E_MODEL_SHELL = smlua_model_util_get_id("kooper_shell_geo")

    -- This is a bitfield of flags that decide which parts of the Bowser Moveset this character will have.
    -- Insert each flag you want to be set, separated by '|' symbols.
    local BOWS_FLAGS_KOOPAS = _G.bowsMoveset.FLAG_CAN_USE_SHELL

    -- Flag Options: (sorry the ids are so long pshgkjdf)

    -- _G.bowsMoveset.FLAG_CAN_USE_SHELL
    --- Allows the character to use the shell slide ability.

    -- _G.bowsMoveset.FLAG_CAN_USE_FIREBALL
    --- Allows the character to use the fire breath ability.

    -- _G.bowsMoveset.FLAG_STYLE_ANIMS
    --- Enables Bowser-unique animations for the character.

    -- _G.bowsMoveset.FLAG_SIZE_ANIMS
    --- Adjusts the character's pose in certain animations to suit bowser's large size. (i.e. ledge grab)

    -- _G.bowsMoveset.FLAG_LARGE_HITBOX
    --- Gives the character a larger hitbox size. (37 -> 85 units radius)
    --- This does not affect the hitbox size for level collision, only collisions with objects.

    -- _G.bowsMoveset.FLAG_NO_CAPLESS
    --- The character does not visually lose their 'cap'. Will also use their 'capless' head state in some animations.
    --- Used by Bowser to allow his jaw to open when breathing fire, etc.

    -- _G.bowsMoveset.FLAG_HEAVY_STEPS
    --- Enables heavier landing sound effects for the character.

    -- _G.bowsMoveset.FLAG_ATTACKS
    --- Enables the alternate sliding punch.

    -- _G.bowsMoveset.FLAG_ALL
    --- Shorthand to set all flags.


    -- This function sets up your custom shell model. Feel free to remove this if you aren't using a shell model.
    -- parameters: [your character model], [your shell model]
    _G.bowsMoveset.character_add_shell_model(E_MODEL_KOOPER, E_MODEL_SHELL)

    _G.bowsMoveset.character_add_shell_model(E_MODEL_PARAKARRY, E_MODEL_SHELL)
   
    -- This function sets up the flags for your character.
    -- parameters: [your character model], [your flag bitfield]
    _G.bowsMoveset.character_set_bows_flags(E_MODEL_KOOPER, BOWS_FLAGS_KOOPAS)

    _G.bowsMoveset.character_set_bows_flags(E_MODEL_PARAKARRY, BOWS_FLAGS_KOOPAS)

end
----

char_add_star(E_MODEL_GOOMBARIO, E_MODEL_STAR_KALMAR, TEX_STAR_KALMAR)
char_add_star(E_MODEL_KOOPER, E_MODEL_STAR_ELDSTAR, TEX_STAR_ELDSTAR)
char_add_star(E_MODEL_BOMBETTE, E_MODEL_STAR_ELDSTAR, TEX_STAR_ELDSTAR)
char_add_star(E_MODEL_PARAKARRY, E_MODEL_STAR_MAMAR, TEX_STAR_MAMAR)
char_add_star(E_MODEL_BOW, E_MODEL_STAR_SKOLAR, TEX_STAR_SKOLAR)
char_add_star(E_MODEL_WATT, E_MODEL_STAR_MUSKULAR, TEX_STAR_MUSKULAR)
char_add_star(E_MODEL_SUSHIE, E_MODEL_STAR_MISSTAR, TEX_STAR_MISSTAR)
char_add_star(E_MODEL_LAKILESTER, E_MODEL_STAR_KLEVAR, TEX_STAR_KLEVAR)


_G.charSelect.character_add_health_meter(CT_KOOPER, PM_KOOPA)
_G.charSelect.character_add_health_meter(CT_PARAKARRY, PM_KOOPA)
_G.charSelect.character_add_health_meter(CT_GOOMBARIO, PM_GOOMBARIO)
_G.charSelect.character_add_health_meter(CT_BOMBETTE, PM_BOMBETTE)
_G.charSelect.character_add_health_meter(CT_BOW, PM_BOW)
_G.charSelect.character_add_health_meter(CT_WATT, PM_WATT)
_G.charSelect.character_add_health_meter(CT_SUSHIE, PM_SUSHIE)
_G.charSelect.character_add_health_meter(CT_LAKILESTER, PM_LAKILESTER)

char_add_voice(E_MODEL_GOOMBARIO, VOICETABLE_GOOMBA)
char_add_voice(E_MODEL_KOOPER, VOICETABLE_KOOPA)
char_add_voice(E_MODEL_PARAKARRY, VOICETABLE_KOOPA)
char_add_voice(E_MODEL_BOMBETTE, VOICETABLE_BOBOMB)
char_add_voice(E_MODEL_WATT, VOICETABLE_WATT)
char_add_voice(E_MODEL_SUSHIE, VOICETABLE_SUSHIE)
char_add_voice(E_MODEL_LAKILESTER, VOICETABLE_LAKILESTER)
char_add_voice(E_MODEL_BOW, VOICETABLE_BOW)


hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
    local v = char_get_voice(m)
    if not v then return end
    if v == VOICETABLE_GOOMBA
        or v == VOICETABLE_KOOPA
        or v == VOICETABLE_BOBOMB
        or v == VOICETABLE_WATT
        or v == VOICETABLE_SUSHIE
        or v == VOICETABLE_LAKILESTER
        or v == VOICETABLE_BOW
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.sound(m, sound)
    end
end)
hook_event(HOOK_MARIO_UPDATE, function(m)
    local v = char_get_voice(m)
    if not v then return end
    if v == VOICETABLE_GOOMBA
        or v == VOICETABLE_KOOPA
        or v == VOICETABLE_BOBOMB
        or v == VOICETABLE_WATT
        or v == VOICETABLE_SUSHIE
        or v == VOICETABLE_LAKILESTER
        or v == VOICETABLE_BOW
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.snore(m)
    end
end)