-- name: [CS] Paper Partners Color Splash + Luigi Partners
-- description: Skinpack of famous friends from the Paper Mario series! \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local E_MODEL_JERRY = smlua_model_util_get_id("jerry_geo")
local E_MODEL_SCREAMY = smlua_model_util_get_id("screamy_geo")
local E_MODEL_HAYZEE = smlua_model_util_get_id("hayzee_geo")
local E_MODEL_BLOOEY = smlua_model_util_get_id("blooey_geo")
local E_MODEL_TORQUE = smlua_model_util_get_id("torque_geo")
local E_MODEL_PRINCESSCC = smlua_model_util_get_id("princesscc_geo")
local E_MODEL_SHYBANDIT = smlua_model_util_get_id("shybandit_geo")
local E_MODEL_PIPER = smlua_model_util_get_id("piper_geo")

local TEX_JERRY = get_texture_info("jerry_icon")
local TEX_SCREAMY = get_texture_info("screamy_icon")
local TEX_HAYZEE = get_texture_info("hayzee_icon")
local TEX_BLOOEY = get_texture_info("blooey_icon")
local TEX_TORQUE = get_texture_info("torque_icon")
local TEX_PRINCESSCC = get_texture_info("princesscc_icon")
local TEX_SHYBANDIT = get_texture_info("shybandit_icon")
local TEX_PIPER = get_texture_info("piper_icon")


local TEXT_MOD_NAME = "[CS] Paper Partners Color Splash + Luigi Partners"




local VOICETABLE_BOBOMB = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Bo_yah.ogg', 'Bo_yah2.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Bo_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Bo_yahoo.ogg',
    [CHAR_SOUND_UH] = 'Bo_uh.ogg',
    [CHAR_SOUND_HRMM] = 'Bo_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'Bo_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'Bo_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'Bo_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Bo_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'Bo_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Bo_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Bo_herewego.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Bo_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Bo_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Bo_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'Bo_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'Bo_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Bo_onfire.ogg',
    [CHAR_SOUND_DYING] = 'Bo_dying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Bo_panting_cold.ogg',
    [CHAR_SOUND_PANTING] = 'Bo_panting.ogg',
    [CHAR_SOUND_COUGHING1] = 'Bo_coughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Bo_coughing2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Bo_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Bo_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Bo_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Bo_groundpound.ogg',
    [CHAR_SOUND_DROWNING] = 'Bo_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Bo_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Bo_yahoo.ogg', 'Bo_waha.ogg', 'Bo_wihee.ogg' },
    [CHAR_SOUND_DOH] = 'Bo_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Bo_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Bo_solongabowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Bo_letsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Bo_okey_dokey.ogg',
}

local VOICETABLE_HAYZEE = {
    [CHAR_SOUND_HERE_WE_GO] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_HOOHOO] = 'jump2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'jump.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_YAHOO] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = { 'jump.ogg', 'jumping2.ogg' },
}

local VOICETABLE_BLOOEY = {
    [CHAR_SOUND_ATTACKED] = 'blo_attacked.ogg',
    [CHAR_SOUND_DOH] = 'blo_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'blo_drowning.ogg',
    [CHAR_SOUND_DYING] = 'blo_dying.ogg',
    [CHAR_SOUND_EEUH] = 'blo_uh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'blo_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'blo_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'blo_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'blo_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'blo_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'blo_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'blo_mamamia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'blo_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'blo_drowning.ogg',
    [CHAR_SOUND_OOOF] = 'blo_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'blo_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'blo_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'blo_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'blo_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'blo_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'blo_twirl_bounce.ogg',
    [CHAR_SOUND_UH] = 'blo_uh.ogg',
    [CHAR_SOUND_UH2] = 'blo_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'blo_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'blo_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'blo_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'blo_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'blo_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'blo_yahoo.ogg', 'blo_yahoo2.ogg', 'blo_yahoo3.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'blo_yah.ogg', 'blo_yah2.ogg' },
}

local VOICETABLE_CHOMP = {
    [CHAR_SOUND_ATTACKED] = 'pcc_attacked.ogg',
    [CHAR_SOUND_DOH] = 'pcc_ooof.ogg',
    [CHAR_SOUND_DROWNING] = 'pcc_dying.ogg',
    [CHAR_SOUND_DYING] = 'pcc_dying.ogg',
    [CHAR_SOUND_EEUH] = 'pcc_uh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'pcc_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'pcc_hoohoo.ogg',
    [CHAR_SOUND_HAHA_2] = 'pcc_hoohoo.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'pcc_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'pcc_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'pcc_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'pcc_mamamia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'pcc_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'pcc_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'pcc_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'pcc_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'pcc_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'pcc_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'pcc_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'pcc_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'pcc_yahoo.ogg',
    [CHAR_SOUND_UH] = 'pcc_uh.ogg',
    [CHAR_SOUND_UH2] = 'pcc_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'pcc_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'pcc_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'pcc_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'pcc_waaaooow.ogg',
    [CHAR_SOUND_YAHOO] = 'pcc_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'pcc_yahoo.ogg', 'pcc_yahoo2.ogg', 'pcc_yahoo3.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'pcc_yah.ogg', 'pcc_yah2.ogg' },
}

local VOICETABLE_SHY = {
    [CHAR_SOUND_ATTACKED] = 'sb_attacked.ogg',
    [CHAR_SOUND_DOH] = 'sb_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'sb_dying.ogg',
    [CHAR_SOUND_DYING] = 'sb_dying.ogg',
    [CHAR_SOUND_EEUH] = 'sb_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'sb_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'sb_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'sb_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'sb_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'sb_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'sb_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'sb_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'sb_letsa_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'sb_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'sb_doh.ogg',
    [CHAR_SOUND_OOOF2] = 'sb_doh.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'sb_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'sb_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'sb_punch_yah.ogg',
    [CHAR_SOUND_SNORING1] = 'sb_snoring1.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'sb_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'sb_so_longa_bowser.ogg',
    [CHAR_SOUND_UH] = 'sb_uh.ogg',
    [CHAR_SOUND_UH2] = 'sb_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'sb_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'sb_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'sb_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'sb_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'sb_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'sb_yahoo.ogg', 'sb_yahoo2.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'sb_yah_wah_hoo1.ogg', 'sb_yah_wah_hoo2.ogg', 'sb_yah_wah_hoo3.ogg' },
}

local VOICETABLE_PLANT = {
    [CHAR_SOUND_ATTACKED] = 'pp_attacked.ogg',
    [CHAR_SOUND_DOH] = 'pp_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'pp_drowning.ogg',
    [CHAR_SOUND_DYING] = 'pp_dying.ogg',
    [CHAR_SOUND_EEUH] = 'pp_doh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'pp_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'pp_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'pp_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'pp_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'pp_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'pp_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'pp_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'pp_letsa_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'pp_dying.ogg',
    [CHAR_SOUND_OOOF] = 'pp_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'pp_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'pp_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'pp_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'pp_punch_yah.ogg',
    [CHAR_SOUND_PANTING] = 'pp_panting.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'pp_solonga_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'pp_twirl_bounce.ogg',
    [CHAR_SOUND_UH] = 'pp_uh.ogg',
    [CHAR_SOUND_UH2] = 'pp_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'pp_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'pp_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'pp_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'pp_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'pp_yahoo.ogg',
    [CHAR_SOUND_YAWNING] = 'pp_yawning.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'pp_yahoo.ogg', 'pp_yahoo2.ogg', 'pp_yahoo3.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'pp_yah_wah_hoo1.ogg', 'pp_yah_wah_hoo2.ogg' },
}

local VOICETABLE_SILENT = { nil }








local capJerry = {
    normal = smlua_model_util_get_id("jerry_cap_geo"),
    wing = smlua_model_util_get_id("jerry_wing_cap_geo"),
    metal = smlua_model_util_get_id("jerry_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("jerry_metal_wing_cap_geo")
}

local capScreamy = {
    normal = smlua_model_util_get_id("screamy_cap_geo"),
    wing = smlua_model_util_get_id("screamy_wing_cap_geo"),
    metal = smlua_model_util_get_id("screamy_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("screamy_metal_wing_cap_geo")
}



local capHayzee = {
    normal = smlua_model_util_get_id("hayzee_cap_geo"),
    wing = smlua_model_util_get_id("hayzee_wing_cap_geo"),
    metal = smlua_model_util_get_id("hayzee_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("hayzee_metal_wing_cap_geo")
}

local capBlooey = {
    normal = smlua_model_util_get_id("blooey_cap_geo"),
    wing = smlua_model_util_get_id("blooey_wing_cap_geo"),
    metal = smlua_model_util_get_id("blooey_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("blooey_metal_wing_cap_geo")
}
local capTorque = {
    normal = smlua_model_util_get_id("torque_cap_geo"),
    wing = smlua_model_util_get_id("torque_wing_cap_geo"),
    metal = smlua_model_util_get_id("torque_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("torque_metal_wing_cap_geo")
}
local capPrincesscc = {
    normal = smlua_model_util_get_id("princesscc_cap_geo"),
    wing = smlua_model_util_get_id("princesscc_wing_cap_geo"),
    metal = smlua_model_util_get_id("princesscc_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("princesscc_metal_wing_cap_geo")
}
local capShybandit = {
    normal = smlua_model_util_get_id("shybandit_cap_geo"),
    wing = smlua_model_util_get_id("shybandit_wing_cap_geo"),
    metal = smlua_model_util_get_id("shybandit_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("shybandit_metal_wing_cap_geo")
}

local capPiper = {
    normal = smlua_model_util_get_id("piper_cap_geo"),
    wing = smlua_model_util_get_id("piper_wing_cap_geo"),
    metal = smlua_model_util_get_id("piper_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("piper_metal_wing_cap_geo")
}

local PALETTE_SCREAMY = {
    [SHIRT] = "FFEDE3",
}

local PALETTE_JERRY = {
    [PANTS] = "951516",
    [SHIRT] = "8e1618",
    [HAIR]  = "9d561e",
}

local PALETTE_HAYZEE = {
    [PANTS] = "d3d0d3",
    [SHIRT] = "8dbf9f",
    [SHOES] = "f7d794",
    [SKIN]  = "f7d794",
}

local PALETTE_BLOOEY = {
    [SHIRT] = "da9938",
}

local PALETTE_TORQUE = {
    [SHIRT]  = "67922E",
    [SKIN]   = "DEC77B",
    [GLOVES] = "FFFFFF",
}

local PALETTE_PRINCESSCC = {
    [SHIRT]  = "000000",
    [PANTS]  = "F4A9AA",
    [GLOVES] = "FFFFFF",
}

local PALETTE_SHYBANDIT = {
    [SHIRT]  = "5A5A5A",
    [PANTS]  = "E2E1DE",
    [SHOES]  = "7E4E29",
    [GLOVES] = "FFFFFF",
    [HAIR]   = "421008",
    [SKIN]   = "F0BA07",
    [CAP]    = "E20807",
}

local PALETTE_PIPER = {
    [SHIRT]  = "FF0000",
    [PANTS]  = "FFFFFF",
    [SHOES]  = "c68026",
    [GLOVES] = "FFFFFF",
    [SKIN]   = "38a31f",
}

local char_add, char_add_caps, char_add_palette, char_add_voice, char_add_star, char_get_voice =
    _G.charSelect.character_add, _G.charSelect.character_add_caps, _G.charSelect.character_add_palette_preset,
    _G.charSelect.character_add_voice, _G.charSelect.character_add_celebration_star, _G.charSelect.character_get_voice


char_add_caps(E_MODEL_JERRY, capJerry)
char_add_caps(E_MODEL_SCREAMY, capScreamy)
char_add_caps(E_MODEL_HAYZEE, capHayzee)
char_add_caps(E_MODEL_BLOOEY, capBlooey)
char_add_caps(E_MODEL_TORQUE, capTorque)
char_add_caps(E_MODEL_PRINCESSCC, capPrincesscc)
char_add_caps(E_MODEL_SHYBANDIT, capShybandit)
char_add_caps(E_MODEL_PIPER, capPiper)




if not _G.charSelectExists then
    djui_popup_create(
        "\\#ffffdc\\\n" ..
        TEXT_MOD_NAME ..
        "\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!",
        6)
    return
end


CT_BLOOEY = char_add("Blooey",
    "Known to his friends as the White Torpedo, is a feisty Blooper who joins Luigi on his quest to rescue Princess Eclair. Although Luigi claims to have successfully thrown Blooey at a monster, killing the golem, he actually tripped and sent Blooey crashing into lava, turning Blooey golden tan.",
    "Melzinoff", { r = 200, g = 164, b = 61 }, E_MODEL_BLOOEY, CT_TOAD, TEX_BLOOEY)
CT_JERRY = char_add("Jerry",
    "He's really burning with a righteous fire, and I think he's seen some...horrible...things.", "Melzinoff",
    { r = 206, g = 65, b = 0 }, E_MODEL_JERRY, CT_MARIO, TEX_JERRY)
CT_TORQUE = char_add("Torque",
    "I hear he's like, a totally excellent mechanic. According to Mechanics Weekly... that tool on his back can basically do anything. He seems ticked off, though.",
    "Melzinoff", { r = 103, g = 146, b = 46 }, E_MODEL_TORQUE, CT_MARIO, TEX_TORQUE)
CT_HAYZEE = char_add("Hayzee",
    "Hayzee is a Crazee Dayzee with green petals, whom Luigi meets during his quest to assemble the Marvelous Compass. Hayzee lived in Jazzafrazz Town, where he wrote a musical entitled The Mystery of The Fiery Hat of Social Awareness for the annual Jazzafrazz Town Drama Slam.",
    "Melzinoff", { r = 161, g = 194, b = 174 }, E_MODEL_HAYZEE, CT_TOAD, TEX_HAYZEE)
CT_SCREAMY = char_add("Screamy", "He must deliver something...", "Melzinoff",
    { r = 204, g = 204, b = 204 }, E_MODEL_SCREAMY, CT_MARIO, TEX_SCREAMY)
CT_PRINCESSCC = char_add("Princess",
    "Professor Kinopio's Chain Chomp, Princess really lives up to her name, doesn't she? Of course, she could also live up to the name Bruiser or Crusher or Goliath...",
    "Melzinoff", { r = 227, g = 199, b = 200 }, E_MODEL_PRINCESSCC, CT_MARIO, TEX_PRINCESSCC)
CT_SHYBANDIT = char_add("The Shy Bandit",
    "A Black Shy Guy who was banished from his homeland, according to a rumor. He is quite the slurper, beware of his fast straw!",
    "Melzinoff", { r = 113, g = 113, b = 113 }, E_MODEL_SHYBANDIT, CT_MARIO, TEX_SHYBANDIT)
CT_PIPER = char_add("Piper",
    "A friendly Ptooie friends with five colorful toads, each having received help from him, due to his friendly help, the toads united to revive him using the rainbow carnation he now wears as a brooch.",
    "Melzinoff", { r = 255, g = 0, b = 0 }, E_MODEL_PIPER, CT_MARIO, TEX_PIPER)

do

end


char_add_palette(E_MODEL_JERRY, PALETTE_JERRY)

char_add_palette(E_MODEL_SCREAMY, PALETTE_SCREAMY)

char_add_palette(E_MODEL_HAYZEE, PALETTE_HAYZEE)
char_add_palette(E_MODEL_BLOOEY, PALETTE_BLOOEY)
char_add_palette(E_MODEL_TORQUE, PALETTE_TORQUE)
char_add_palette(E_MODEL_PRINCESSCC, PALETTE_PRINCESSCC)
char_add_palette(E_MODEL_SHYBANDIT, PALETTE_SHYBANDIT)
char_add_palette(E_MODEL_PIPER, PALETTE_PIPER)

---- BOWSER Compatibility:
if _G.bowsMoveset then
    -- Retrieves the custom shell model for this character. Check template_shell.blend for how to set up a shell model properly.

    local E_MODEL_TOR_SHELL = smlua_model_util_get_id("torque_shell_geo")

    -- This is a bitfield of flags that decide which parts of the Bowser Moveset this character will have.
    -- Insert each flag you want to be set, separated by '|' symbols.
    local BOWS_FLAGS_KOOPAS = _G.bowsMoveset.FLAG_CAN_USE_SHELL

    -- Flag Options: (sorry the ids are so long pshgkjdf)

    -- _G.bowsMoveset.FLAG_CAN_USE_SHELL
    --- Allows the character to use the shell slide ability.

    -- _G.bowsMoveset.FLAG_CAN_USE_FIREBALL
    --- Allows the character to use the fire breath ability.

    -- _G.bowsMoveset.FLAG_STYLE_ANIMS
    --- Enables Bowser-unique animations for the character.

    -- _G.bowsMoveset.FLAG_SIZE_ANIMS
    --- Adjusts the character's pose in certain animations to suit bowser's large size. (i.e. ledge grab)

    -- _G.bowsMoveset.FLAG_LARGE_HITBOX
    --- Gives the character a larger hitbox size. (37 -> 85 units radius)
    --- This does not affect the hitbox size for level collision, only collisions with objects.

    -- _G.bowsMoveset.FLAG_NO_CAPLESS
    --- The character does not visually lose their 'cap'. Will also use their 'capless' head state in some animations.
    --- Used by Bowser to allow his jaw to open when breathing fire, etc.

    -- _G.bowsMoveset.FLAG_HEAVY_STEPS
    --- Enables heavier landing sound effects for the character.

    -- _G.bowsMoveset.FLAG_ATTACKS
    --- Enables the alternate sliding punch.

    -- _G.bowsMoveset.FLAG_ALL
    --- Shorthand to set all flags.


    -- This function sets up your custom shell model. Feel free to remove this if you aren't using a shell model.
    -- parameters: [your character model], [your shell model]

    _G.bowsMoveset.character_add_shell_model(E_MODEL_TORQUE, E_MODEL_TOR_SHELL)
    -- This function sets up the flags for your character.
    -- parameters: [your character model], [your flag bitfield]

    _G.bowsMoveset.character_set_bows_flags(E_MODEL_TORQUE, BOWS_FLAGS_KOOPAS)
end
----







char_add_voice(E_MODEL_JERRY, VOICETABLE_BOBOMB)

char_add_voice(E_MODEL_SCREAMY, VOICETABLE_SILENT)

char_add_voice(E_MODEL_HAYZEE, VOICETABLE_HAYZEE)
char_add_voice(E_MODEL_BLOOEY, VOICETABLE_BLOOEY)
char_add_voice(E_MODEL_TORQUE, VOICETABLE_SILENT)
char_add_voice(E_MODEL_PRINCESSCC, VOICETABLE_CHOMP)
char_add_voice(E_MODEL_SHYBANDIT, VOICETABLE_SHY)
char_add_voice(E_MODEL_PIPER, VOICETABLE_PLANT)


hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
    local v = char_get_voice(m)
    if not v then return end
    if  v == VOICETABLE_BOBOMB
        or v == VOICETABLE_HAYZEE
        or v == VOICETABLE_BLOOEY
        or v == VOICETABLE_CHOMP
        or v == VOICETABLE_SHY
        or v == VOICETABLE_PLANT
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.sound(m, sound)
    end
end)
hook_event(HOOK_MARIO_UPDATE, function(m)
    local v = char_get_voice(m)
    if not v then return end
    if     v == VOICETABLE_BOBOMB
        or v == VOICETABLE_HAYZEE
        or v == VOICETABLE_BLOOEY
        or v == VOICETABLE_CHOMP
        or v == VOICETABLE_SHY
        or v == VOICETABLE_PLANT
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.snore(m)
    end
end)

-- table to associate animation IDs with our registered lua animation names
local torqueAnims = {
    [CHAR_ANIM_SLOW_LEDGE_GRAB] = 'torque_ledgeup',
    [CHAR_ANIM_BACKWARD_AIR_KB] = 'torque_backward_air_kb',
    [CHAR_ANIM_CLIMB_DOWN_LEDGE] = 'torque_climb_down_ledge',
    [CHAR_ANIM_DIVE] = 'torque_dive',
    [CHAR_ANIM_FALL_FROM_SLIDE] = 'torque_fall_from_slide',
    [CHAR_ANIM_FALL_OVER_BACKWARDS] = 'torque_fall_over_back',
    [CHAR_ANIM_FAST_LEDGE_GRAB] = 'torque_fast_ledge',
    [CHAR_ANIM_FIRST_PERSON] = 'torque_firstperson',
    [CHAR_ANIM_FORWARD_KB] = 'torque_forward_kb',
    [CHAR_ANIM_FORWARD_SPINNING_FLIP] = 'torque_forward_spinning',
    [CHAR_ANIM_HANDSTAND_JUMP] = 'torque_handstand_jump',
    [CHAR_ANIM_HEAD_STUCK_IN_GROUND] = 'torque_head_stuck',
    [CHAR_ANIM_IDLE_HEAD_CENTER] = 'torque_idle_c',
    [CHAR_ANIM_IDLE_HEAD_LEFT] = 'torque_idle_l',
    [CHAR_ANIM_IDLE_HEAD_RIGHT] = 'torque_idle_r',

    [CHAR_ANIM_SLIDE_DIVE] = 'torque_slide_dive',
    [CHAR_ANIM_SLOW_LAND_FROM_DIVE] = 'torque_slow_land_dive',
    [CHAR_ANIM_START_CRAWLING] = 'torque_start_crawling',
    [CHAR_ANIM_STOP_CRAWLING] = 'torque_stop_crawling',
    [CHAR_ANIM_CRAWLING] = 'torque_crawling',
    [CHAR_ANIM_STOP_SLIDE] = 'torque_stop_slide',
    [CHAR_ANIM_STOP_SLIDE_LIGHT_OBJ] = 'torque_stop_slide_light_obj',
    [CHAR_ANIM_SLIDE] = 'torque_slide',
    [CHAR_ANIM_IDLE_ON_LEDGE] = 'torque_idle_on_edge',
    [CHAR_ANIM_START_SLEEP_SITTING] = 'torque_start_sleep_sitting',
    [CHAR_ANIM_SLEEP_IDLE] = 'torque_sleep',


}

-- table associating animation IDs with rotation offsets
local torqueRotOffsets = {
    [CHAR_ANIM_DYING_ON_BACK] = 90,
    [CHAR_ANIM_DYING_ON_STOMACH] = -90,
    [CHAR_ANIM_GRAB_POLE_SHORT] = -80,
    [CHAR_ANIM_GRAB_POLE_SWING_PART1] = -80,
    [CHAR_ANIM_GRAB_POLE_SWING_PART2] = -80,
    [CHAR_ANIM_IDLE_ON_POLE] = -80,
    [CHAR_ANIM_CLIMB_UP_POLE] = -80,
    [CHAR_ANIM_START_HANDSTAND] = -80,
    [CHAR_ANIM_RETURN_FROM_HANDSTAND] = -80,
    [CHAR_ANIM_HANDSTAND_IDLE] = -80,
    [CHAR_ANIM_WATER_IDLE] = -45,
    [CHAR_ANIM_WATER_FORWARD_KB] = -45,
    [CHAR_ANIM_BACKWARDS_WATER_KB] = -45,
    [CHAR_ANIM_SWIM_PART1] = -45,
    [CHAR_ANIM_SWIM_PART2] = -45,
    [CHAR_ANIM_FLUTTERKICK] = -45,
    [CHAR_ANIM_WATER_THROW_OBJ] = -45,
    [CHAR_ANIM_WATER_GRAB_OBJ_PART1] = -45,
    [CHAR_ANIM_WATER_GRAB_OBJ_PART2] = -45,
    [CHAR_ANIM_WATER_ACTION_END] = -45,
}
-- convert angles from degrees to s16
for key, value in pairs(torqueRotOffsets) do
    torqueRotOffsets[key] = value / 180 * 0x8000
end

---@param m MarioState
local function mario_update(m)
    -- check for torque flag; must update animations on every client's end
    if gPlayerSyncTable[m.playerIndex].torque then
        local animID = m.marioObj.header.gfx.animInfo.animID

        -- replaced animations
        local luaAnimID = torqueAnims[animID]
        if luaAnimID then
            -- if the current anim ID has a valid lua anim ID associated with it, play the custom animation
            smlua_anim_util_set_animation(m.marioObj, luaAnimID)
        end

        -- animation rot offsets through code
        local rotOffset = torqueRotOffsets[animID]
        if rotOffset then
            -- if the current anim ID has an associated rotation offset, apply it
            local gfx = m.marioObj.header.gfx
            gfx.angle.x = gfx.angle.x + rotOffset
            -- adjust vertical model position to account for the rotation
            gfx.pos.y = gfx.pos.y + math.max(0, math.abs(rotOffset) - 0x4000) / 0x0200
        end
    end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)

hook_event(HOOK_UPDATE, function()
    -- flag to determine if a player is torque (boolean)
    -- this is done in the local update hook because character select can only check for the local player's numbers
    -- gPlayerSyncTable auto syncs the result to all clients
    gPlayerSyncTable[0].torque = (_G.charSelect.character_get_current_number() == CT_TORQUE)
end)
